;memory adresses provided by the fpga
state			equ	$fa4000
readyFlag		equ	$fa4002
uploadCount		equ	$fa4004
stateFPGA		equ	$fa4006
byteCount		equ $fa4008
stateFPGARet 	equ	$fa400a

onoff 			equ	$fa4022
cartridgeUp		equ	$fa403c
cartridgeDown	equ	$fa403e

block1Pos		equ	$fa8000
block2Pos		equ	$faa000
;ram values
;zeroPageBackup		equ	$3f2000	; len $1000
;cartridgePos		equ	$3f4000	; len $4000 >up
zeroPageBackupLen	equ	$1000
sspLen				equ	$800
uspLen				equ	$800
cartridgeLen		equ	$4000
ramLen				equ	$200
screenLen			equ	$8000	

;ssp		$3f2e00-$3f3600
;usp		$3f3600-$3f3e00
;cart		$3f3e00-$3f7e00
;ram		$3f7e00-$3f8000
;screen		$3f8000-$3ffd00

ramValuePos			equ $0
udPrgAdr			equ	ramValuePos+$0000
udPrgAdrCopy 		equ	ramValuePos+$0004
udStateCopy			equ	ramValuePos+$0008
udPrgLen			equ ramValuePos+$000c
udSymboltable		equ ramValuePos+$0010
udBugabooLoadFlag 	equ ramValuePos+$0014
udMyBasePage		equ ramValuePos+$0016
udSymboltablelen	equ ramValuePos+$001a
udZeroPageMagicPos 	equ ramValuePos+$001c
udZeroPageMagic		equ $DEAD
udBugaBooCmdListPos	equ ramValuePos+$0020

driveBpb			equ	ramValuePos+$0024
driveBpbSectorSize	equ	ramValuePos+$0024		;bytes per sector
driveBpbClSize		equ	ramValuePos+$0026		;sectors per cluster
driveBpbClSizeBytes	equ	ramValuePos+$0028		;bytes per cluster
driveBpbRootSize	equ	ramValuePos+$002a		;directory len in sectors
driveBpbFatSize		equ	ramValuePos+$002c		;fat size in sectors
driveBpbFatSector	equ	ramValuePos+$002e		;start sector of second fat
driveBpbDataSector	equ	ramValuePos+$0030		;start sector of data (boot 1 + rdlen 7 + fsiz*2 10 ) == 18
driveBpbClNum		equ	ramValuePos+$0032
driveBpbFlags		equ	ramValuePos+$0034		;0=12 bit fat... 1=16 fat


driveCacheSec1		equ	ramValuePos+$0038
driveCacheSec2		equ	ramValuePos+$003a
fontPosition		equ	ramValuePos+$003e
cpuType				equ	ramValuePos+$0042
machineType			equ	ramValuePos+$0044
oldTrap1			equ	ramValuePos+$0046

// + buffers for tos

;code page
p_lowtpa 	equ $00	;base of TPA
p_hitpa 	equ $04	;end of TPA
p_tbase		equ $08	;base of text segment
p_tlen 		equ $0c	;size of text segment
p_dbase 	equ $10	;base of data segment
p_dlen 		equ $14	;size of data segment
p_bbase 	equ $18	;size of BSS segment
p_blen 		equ $1c	;base of BSS segment
p_dta 		equ $20	;Disk Transfer Address (DTA)
p_parent 	equ $24	;parent's basepage
p_env 		equ $2c	; enviroment string
p_cmdlin 	equ $80	;commandline image
;file header
hdrMagic 		equ $00	;Ox601A (magic number)
hdrSizeText		equ	$02	;Size of text segment
hdrSizeData		equ	$06	;Size of data segment
hdrSizeBss		equ	$0a	;Size of BSS segment
hdrSizeSymbol	equ	$0e	;Size of symbol table
hdrStartText	equ	$1e	;start of text segment)

;firmwareVersion equ	$0052

; states for the 68k state machine
stateIdle			equ	0
stateStartPrgSetup	equ	1
stateCopyBlock1		equ	2
stateCopyBlock2		equ	3
stateRunPrg			equ	4